package cds;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ArrayBlockingQueue;

/**
 * BQueueBoundedBuffer
 * <p/>
 * Bounded buffer using BlockingQueue
 *
 * This implementation has been obtained reworking an original class 
 * by Brian Goetz and Tim Peierls
 *
 * @param <T>
 */

public class BQueueBoundedBuffer<T> implements BoundedBufferInterface<T> {

    private final BlockingQueue<T> myQueue;


    public BQueueBoundedBuffer(int capacity, boolean fairness) {
        if (capacity <= 0) {
            throw new IllegalArgumentException();
        }
        myQueue = new ArrayBlockingQueue(capacity, fairness);//fairness=true
    }


    @Override
    public void put(T x) throws InterruptedException {
        
        myQueue.put(x);
    }

    @Override
    public T take() throws InterruptedException {
        
        return myQueue.take();
    }

}
